Loading...
Searching...
No Matches
Opm::WellContributionsRocsparse< Scalar > Class Template Reference
Inheritance diagram for Opm::WellContributionsRocsparse< Scalar >:

## Public Member Functions

void | apply_stdwells (Scalar *d_x, Scalar *d_y)
void | apply_mswells (Scalar *d_x, Scalar *d_y)
void | apply (Scalar *d_x, Scalar *d_y)
void | setStream (hipStream_t stream)
Public Member Functions inherited from Opm::WellContributions< Scalar >
unsigned int | getNumWells ()
void | addNumBlocks (unsigned int numBlocks)
| Indicate how large the next StandardWell is, this function cannot be called after alloc() is called.
void | alloc ()
| Allocate memory for the StandardWells.
virtual | ~WellContributions ()
| Empty destructor.
void | setBlockSize (unsigned int dim, unsigned int dim_wells)
| Indicate how large the blocks of the StandardWell (C and B) are.
void | setVectorSize (unsigned N)
| Set size of vector that the wells are applied to.
void | addMatrix (MatrixType type, int *colIndices, Scalar *values, unsigned int val_size)
| Store a matrix in this object, in blocked csr format, can only be called after alloc() is called.
void | addMultisegmentWellContribution (unsigned int dim, unsigned int dim_wells, unsigned int Mb, std::vector< Scalar > &Bvalues, std::vector< unsigned int > &BcolIndices, std::vector< unsigned int > &BrowPointers, unsigned int DnumBlocks, Scalar *Dvalues, UMFPackIndex *DcolPointers, UMFPackIndex *DrowIndices, std::vector< Scalar > &Cvalues)
| Add a MultisegmentWellContribution, actually creates an object on heap that is destroyed in the destructor Matrices C and B are passed in Blocked CSR, matrix D in CSC.

## Protected Types

using | MatrixType = typename WellContributions<Scalar>::MatrixType

## Protected Member Functions

void | APIalloc () override
| Allocate memory for the StandardWells.
void | APIaddMatrix (MatrixType type, int *colIndices, Scalar *values, unsigned int val_size) override
| Api specific upload of matrix.

## Protected Attributes

Scalar * | d_Cnnzs_hip
Scalar * | d_Dnnzs_hip
Scalar * | d_Bnnzs_hip
unsigned * | d_Ccols_hip
unsigned * | d_Bcols_hip
unsigned * | d_val_pointers_hip
std::vector< Scalar > | h_x
std::vector< Scalar > | h_y
Protected Attributes inherited from Opm::WellContributions< Scalar >
bool | allocated = false
unsigned int | N
unsigned int | dim
unsigned int | dim_wells
unsigned int | num_blocks = 0
unsigned int | num_std_wells = 0
unsigned int | num_ms_wells = 0
unsigned int | num_blocks_so_far = 0
unsigned int | num_std_wells_so_far = 0
std::vector< unsigned int > | val_pointers
std::vector< std::unique_ptr< MultisegmentWellContribution< Scalar > > > | multisegments

## Additional Inherited Members

Public Types inherited from Opm::WellContributions< Scalar >
enum class | MatrixType { C , D , B }
| StandardWell has C, D and B matrices that need to be copied.
using | UMFPackIndex = SuiteSparse_long
Static Public Member Functions inherited from Opm::WellContributions< Scalar >
static std::unique_ptr< WellContributions > | create (const std::string &accelerator_mode, bool useWellConn)

## Member Function Documentation

## APIaddMatrix()

template<class Scalar>

void Opm::WellContributionsRocsparse< Scalar >::APIaddMatrix | ( | MatrixType | ,
|  | int * | ,
|  | Scalar * | ,
|  | unsigned int | )

override protected virtual

Api specific upload of matrix.

Reimplemented from Opm::WellContributions< Scalar >.

## APIalloc()

template<class Scalar>

void Opm::WellContributionsRocsparse< Scalar >::APIalloc | ( |  | ) |

override protected virtual

Allocate memory for the StandardWells.

Reimplemented from Opm::WellContributions< Scalar >.

The documentation for this class was generated from the following files:

- opm/simulators/linalg/gpubridge/rocm/rocsparseWellContributions.hpp
- opm/simulators/linalg/gpubridge/rocm/rocsparseWellContributions.cpp